#include "simple-plugin-view.h"

PluginView::PluginView(BRect rect) : BView(rect, "pluginbarnet", B_FOLLOW_ALL_SIDES, B_WILL_DRAW) {
  thread_id thread = spawn_thread(Thread,
                                 "plugin", 
                                 B_LOW_PRIORITY,
                                 this); 
  if (thread > 0)
    resume_thread(thread);
  Show();
}

int32 PluginView::Thread(void *arg) { 
  PluginView *view = (PluginView *)arg; 
  while (true) {
    if (view->LockLooper()) {
      view->Invalidate();
      view->UnlockLooper();
    }
    snooze(500000); 
  }  
}

void PluginView::Draw(BRect rect) {
  if (LockLooper()) {
    BFont font;
    font.SetFamilyAndStyle("CopprplGoth Bd BT", "Bold");
	font.SetSize(13);
    SetFont(&font);

	int8 r = rand() % 256;
	int8 g = rand() % 256;
	int8 b = rand() % 256;

	SetLowColor(r, g, b);
	SetHighColor(r, g, b);
	FillRect(rect);
	SetHighColor(!r, !g, !b);
	
	DrawString("Burning down the house!", BPoint(10, 50));
    UnlockLooper();
  }
}